'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _swapArrayElements = require('./swapArrayElements');

var _swapArrayElements2 = _interopRequireDefault(_swapArrayElements);

var _isMouseBeyond = require('./isMouseBeyond');

var _isMouseBeyond2 = _interopRequireDefault(_isMouseBeyond);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

exports.default = function (Component) {
  var elementEdge = 0;
  var updateEdge = true;

  return _react2.default.createClass({

    proptypes: {
      items: _react2.default.PropTypes.array.isRequired,
      updateState: _react2.default.PropTypes.func.isRequired,
      sortId: _react2.default.PropTypes.number,
      outline: _react2.default.PropTypes.string.isRequired, // row | column
      draggingIndex: _react2.default.PropTypes.number
    },

    getInitialState: function getInitialState() {
      return {
        draggingIndex: null
      };
    },
    componentWillReceiveProps: function componentWillReceiveProps(next) {
      this.setState({
        draggingIndex: next.draggingIndex
      });
    },
    sortEnd: function sortEnd() {
      this.props.updateState({
        draggingIndex: null
      });
    },
    sortStart: function sortStart(e) {
      var draggingIndex = e.currentTarget.dataset.id;
      this.props.updateState({
        draggingIndex: draggingIndex
      });
      this.setState({
        draggingIndex: draggingIndex
      });
      if (e.dataTransfer !== undefined) {
        e.dataTransfer.setData('text', e.target);
      }
      updateEdge = true;
    },
    dragOver: function dragOver(_ref) {
      var clientX = _ref.clientX;
      var clientY = _ref.clientY;
      var type = _ref.type;
      var currentTarget = _ref.currentTarget;

      var mouseBeyond = void 0;
      var positionX = void 0,
          positionY = void 0;
      var height = void 0,
          topOffset = void 0;
      var items = this.props.items;
      var indexDragged = Number(currentTarget.dataset.id); // index of underlying element in the set DOM elements
      var indexFrom = Number(this.state.draggingIndex);

      height = currentTarget.getBoundingClientRect().height;

      if (type === 'dragover') {
        positionX = clientX;
        positionY = clientY;
        topOffset = currentTarget.getBoundingClientRect().top;
      }

      if (type === 'touchmove') {
        positionX = touches[0].pageX;
        positionY = touches[0].pageY;

        if (updateEdge) {
          elementEdge = currentTarget.getBoundingClientRect().top;
          updateEdge = false;
        }
        // bad, I need to copy and then move
        // e.currentTarget.style.top = (positionY - elementEdge) + 'px'
        topOffset = elementEdge;
      }

      if (this.props.outline === 'list') {
        mouseBeyond = (0, _isMouseBeyond2.default)(positionY, topOffset, height);
      }

      if (this.props.outline === 'column') {
        mouseBeyond = (0, _isMouseBeyond2.default)(positionX, currentTarget.getBoundingClientRect().left, currentTarget.getBoundingClientRect().width);
      }

      if (indexDragged !== indexFrom && mouseBeyond) {
        items = (0, _swapArrayElements2.default)(items, indexFrom, indexDragged);
        this.props.updateState({
          items: items, draggingIndex: indexDragged
        });
      }
    },
    isDragging: function isDragging() {
      return this.props.draggingIndex === this.props.sortId;
    },
    render: function render() {
      var draggingClassName = Component.displayName + '-dragging';
      var _props = this.props;
      var sortId = _props.sortId;

      var props = _objectWithoutProperties(_props, ['sortId']);

      return _react2.default.createElement(Component, _extends({
        draggable: true,
        className: this.isDragging() ? draggingClassName : '',
        onDragOver: this.dragOver,
        onDragStart: this.sortStart,
        onDragEnd: this.sortEnd,
        onTouchStart: this.sortStart,
        onTouchMove: this.dragOver,
        onTouchEnd: this.sortEnd,
        'data-id': sortId
      }, props));
    }
  });
};